require "test/unit"
require "Matriz.rb"
require "Fraccion.rb"
require "Matriz_densa.rb"
require "Matriz_dispersa.rb"

class Test_Matriz < Test::Unit::TestCase
	
	#Inicializador de los objetos
	def setup
	@m1=Matriz_dispersa.new([[1,0,0],[0,1,0],[0,0,0]]) #dispersa
	@m2=Matriz_densa.new([[1,2,1],[2,1,3],[3,5,4]]) #densa
        @m3=Matriz_dispersa.new([[1,0,0],[0,0,0],[1,0,0]]) #dispersa
        @m4=Matriz_densa.new([[2,3,1],[9,3,4],[2,7,5]]) #densa
	end



	#Test para comprobar la correcta construcción de las matrices
	def test_Comprobacion

	assert_equal(@m1.filas,3)
        assert_equal(@m1.cols,3)
	 
	assert_equal(@m2.filas,3)
        assert_equal(@m2.cols,3)

	assert_equal(@m3.filas,3)
        assert_equal(@m3.cols,3)
	
	assert_equal(@m4.filas,3)
        assert_equal(@m4.cols,3)

	end



	#Test para comprobar la correcta construcción de las matrices según el tipo
	def test_Tipo
	
	assert_equal(true, @m1.is_a?(Matriz_dispersa))
	assert_equal(true, @m2.is_a?(Matriz_densa))
	assert_equal(true, @m3.is_a?(Matriz_dispersa))
	assert_equal(true, @m4.is_a?(Matriz_densa))	


	end


	#Test para comprobar las operaciones entre matrices
	def test_Operacion

#suma
	assert_equal(Matriz_dispersa.new([[2,0,0],[0,1,0],[1,0,0]]).matriz, (@m1 + @m3).matriz)
	assert_equal(Matriz_densa.new([[2,2,1],[2,2,3],[3,5,4]]).matriz,(@m1+@m2).matriz)

#resta

	assert_equal(Matriz_densa.new([[0,-2,-1],[-2,0,-3],[-3,-5,-4]]).matriz,(@m1-@m2).matriz)
	assert_equal(Matriz_dispersa.new([[0,0,0],[0,1,0],[-1,0,0]]).matriz,(@m1-@m3).matriz)

#multiplicacion

	assert_equal(Matriz_densa.new([[2,3,1],[0,0,0],[2,3,1]]).matriz,(@m3*@m4).matriz)
	assert_equal(Matriz_densa.new([[22,16,14],[19,30,21],[59,52,43]]).matriz,(@m2*@m4).matriz)

	end

end


